<?php
/*	name : Module Plugin Hello world
	author: team1/3
	
	カスタムページのサンプル(Hello world)
	
	1. ページに任意の文字列 Hello world を追加するサンプル
	2. テンプレートの指定方法
	
	※ グローバル変数
	   $config ... OneThird CMSの固定値（変更不可)
	   $params ... OneThird CMSのパラメータ（変更可能)
	   $html   ... ページ作成のためのバッファ

	※ ページレタリングの仕組み
	   1.グローバル変数 $html の各種値をセット
	   　よく使う $htmlのメンバ
	   　$html['head'] ... ヘッダ部分
	   　$html['css'] ... 追加CSSを指定
	   　$html['article'] ... ページ本文
	   　$html['meta'] ... 主にscriptを指定
	   
	   2.$params['tmplate'] に設定されているファイルに $htmlの値を流し込み echoする

	※ このサンプルでは、よく使うプログラムをコメント形式で書いています
	   コメントを外して使用してください
	
	
*/

	global $html,$params,$ut;

	if (!isset($config)) { die(); }	// 単体で動作しないように対策

	$params['rendering'] = false;	// 標準レンダラーを無効に
	$page_ar = $params['page'];

	/*
	//追加CSS 
$html['css']['custom_page'] = <<<EOT
	<style>
		.hello_world {
			font-size:300%;
			margin: 100px auto;
			width: 500px;
			text-align: center;
		}
	</style>
EOT;
	*/

	// 通常表示
	$html['article'][] = "<p class='hello_world'>Hello world</p>";

	/* $params['page']について
	$params['page']はページ配列
	
	ページ内容の各種情報が収納されている
	$page_ar['id'] ... ページ番号
	$page_ar['type'] ... ページタイプ 通常:1 , その他プラグイン番号 例 ページフォルダ180
	$page_ar['block_type'] ... ページ属性 通常:1 , 15以上 EDITユーザー以上が見れる、20以上ログインユーザー以上が見れる
	$page_ar['contents'] ... ページ本文
	$page_ar['mode'] ... 通常:1, 下書:0, トップページ:2
	$page_ar['title'] ... ページタイトル
	$page_ar['date'] ... 作成日
	$page_ar['mod_date'] ... 最終更新日
	$page_ar['user'] ... 編集言言を持っているユーザー
	$page_ar['meta'] ... metaデータプラグインや、その他設定データ、カスタムデータの書き込みもOK
	*/


	/* 
	//テンプレートは省略された場合 default.tplを使用
	(パスは、/files/1/data )
	$params['template'] = 'blog_top.tpl';
	*/

	/*
	//テンプレートは、ファイルではなく文字列を割り当てることも可能
$params['template_buff'] = <<<EOT
<!doctype html>
<html lang="ja" xmlns="http://www.w3.org/1999/xhtml">
  <head>

    {\$load('php',".data/preload")}
    {\$ut->expand('head')}
    <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
    {\$load('css',"{$params['data_url']}skeleton/skeleton-onethird",'inline')}
    {\$load('css',"{$config['site_url']}css/onethird.8")}
    {\$load('less',"{$params['data_url']}theme")}
    {\$ut->expand('css',1)}
  </head>

  <body >

    <div style='display:block' >
        {\$ut->expand('article')}
    </div>

    {\$load('jquery')}
    {\$call('system_toolbar')}
    {\$ut->expand('meta')}
  </body>
</html>
EOT;
	*/


?>