<?php
/*	name : Module Plugin Sample (DB,List)
	author: team1/3
	
	カスタムページのサンプル
	1. DBへのアクセス

	※ グローバル変数
	   $config ... OneThird CMSの固定値（変更不可)
	   $params ... OneThird CMSのパラメータ（変更可能)
	   $html   ... ページ作成のためのバッファ

	※ ページレタリングの仕組み
	   1.グローバル変数 $html の各種値をセット
	   　よく使う $htmlのメンバ
	   　$html['head'] ... ヘッダ部分
	   　$html['css'] ... 追加CSSを指定
	   　$html['article'] ... ページ本文
	   　$html['meta'] ... 主にscriptを指定
	   
	   2.$params['tmplate'] に設定されているファイルに $htmlの値を流し込み echoする

	※ このサンプルでは、よく使うプログラムをコメント形式で書いています
	   コメントを外して使用してください
	※ コメント部分は順番を入れ替えても動作します
	
	
*/

	global $params,$config;

	if (!isset($config)) { die(); }

	draw();

	$params['rendering'] = false;	// 標準ページを使う場合コメントアウト

function draw()
{
	global $html,$params,$database,$ut;
	
	$page_ar = $params['page'];

	/* $params['page']について
	$params['page']はページ配列
	
	ページ内容の各種情報が収納されている
	$page_ar['id'] ... ページ番号
	$page_ar['type'] ... ページタイプ 通常:1 , その他プラグイン番号 例 ページフォルダ180
	$page_ar['block_type'] ... ページ属性 通常:1 , 15以上 EDITユーザー以上が見れる、20以上ログインユーザー以上が見れる
	$page_ar['contents'] ... ページ本文
	$page_ar['mode'] ... 通常:1, 下書:0, トップページ:2
	$page_ar['title'] ... ページタイトル
	$page_ar['date'] ... 作成日
	$page_ar['mod_date'] ... 最終更新日
	$page_ar['user'] ... 編集言言を持っているユーザー
	$page_ar['meta'] ... metaデータプラグインや、その他設定データ、カスタムデータの書き込みもOK
	*/

	/* 
	//追加CSS 
$html['css']['custom_page'] = <<<EOT
	<style>
	</style>
EOT;
	*/


	$option = array();
	$option['total'] = 0;
	if (isset($_GET['offset'])) {
		$option['offset'] = (int)$_GET['offset'];
	} else {
		$option['offset'] = 0;
	}
	$option['page_size'] = 5;
	$option['offset_name'] = 'offset';
	$option['url'] = $params['request'];

	$sql = array();
	$sql[0] = "select count(id) as c from ".DBX."data_items ";
	$sql[1] = array(" where block_type =10");
	$sql[2] = array(" and type <> ? ",PAGE_FOLDER_ID);

	if (check_rights()) {
		$sql[3] = array(' and (mode=1 or (mode=0 and user=?)) ',(int)($_SESSION['login_id']));
	} else {
		$sql[3] = array(' and mode=1 ');
	}

	// count
	$ar = $database->sql_select_all($sql);
	if ($ar) {
		$option['total'] = $ar[0]['c'];
	}

	// page
	$sql[0] = "select id,type,metadata,title,mode,user,date,mod_date from ".DBX."data_items ";
	$sql[]  = array(" {$ut->limit($option['offset']*$option['page_size'], $option['page_size'])} ");
	
	$ar = $database->sql_select_all($sql);

	// 一覧表示
	$buff = '';
	$buff .= std_pagination_renderer( $option ).$buff;
	foreach ($ar as $v) {
$buff .= <<<EOT
		<p>{$v['mod_date']} : <a href='{$ut->link($v['id'])}'>{$v['title']}</a></p>
EOT;
	}
	$html['article'][] = $buff;

}


?>