<?php
/*	name :Module Plugin Sample (Custom Page)
	author: team1/3
	
	カスタムページのサンプル
	1. 標準レンダラーを使わないページ
	2. Ajax によるページ追加
	3. 設定ダイアログの追加
	
	※ グローバル変数
	   $config ... OneThird CMSの固定値（変更不可)
	   $params ... OneThird CMSのパラメータ（変更可能)
	   $html   ... ページ作成のためのバッファ

	※ ページレタリングの仕組み
	   1.グローバル変数 $html の各種値をセット
	   　よく使う $htmlのメンバ
	   　$html['head'] ... ヘッダ部分
	   　$html['css'] ... 追加CSSを指定
	   　$html['article'] ... ページ本文
	   　$html['meta'] ... 主にscriptを指定
	   
	   2.$params['tmplate'] に設定されているファイルに $htmlの値を流し込み echoする

	※ このサンプルでは、よく使うプログラムをコメント形式で書いています
	   コメントを外して使用してください
	
	
*/

	global $html,$params,$config;

	if (!isset($config)) { die(); }

	add_page_menu();				// Add(ページ追加)をブロックメニューに追加
	page_custom_page_setting();		// 設定画面(Setting)をブロックメニューに追加
	draw();

	$params['rendering'] = false;	// 標準レンダラーを使う場合コメントアウト

function draw()
{
	global $html,$params,$ut;
	
	$page_ar = $params['page'];

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		if (check_rights('owner')) {
			//ページ作成者にはログインユーザーでも編集権限を与える
			set_func_rights('edit.modules');		// ページ編集権限
			//set_func_rights('add_page');		// ページ作成権限
			provide_edit_rights();				// 編集権限モジュールの読込
		}
		// ページ編集
		provide_edit_module();					// 編集ツールの読込
		unset($params['breadcrumb']);
		snippet_breadcrumb($params['page']['id'], 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;

	} else {
		// 通常表示
		snippet_breadcrumb($page_ar['link'], $page_ar['title']);
		$buff = plugin_proc('page_folder');		// ページフォルダプラグインを直接呼び出し
		$buff = frame_renderer(body_renderer($page_ar).$buff);
		$buff = custompage_renderer($page_ar['id'],$buff);
		$html['article'][] = $buff;
	}

}

function add_page_menu()
{
	global $html,$params,$ut;

$params['add-blockmenu'][] = <<<EOT
	<a href='javascript:void(ot.plugin_custom_page_make_page({$params['page']['id']},1))' class='onethird-button mini'>Add</a>
EOT;
	if (check_rights() && isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_custom_page_make_page')  {
		$r = array();
		$r['link'] = (int)$_POST['page'];
		$r['result'] = false;
		if (empty($_POST['type'])) {
			echo( json_encode($r) );
			exit();
		}
		$r['type'] = (int)($_POST['type']);
		if ($r['type'] == PAGE_FOLDER_ID) {
			$r['title'] = 'Folder-'.substr(time(),-4);
			$r['block_type'] = 1;
			//$r['meta']['template_ar']['php'] = ".".basename(__FILE__);		// 自分自身を強制コピー
			//$r['meta']['lwr_template_ar']['php'] = ".".basename(__FILE__);
		} else {
			$r['title'] = 'PAGE-'.substr(time(),-4);
			$r['block_type'] = 1;
			//$r['meta']['template_ar']['php'] = ".".basename(__FILE__);		// 自分自身を強制コピー
		}
		create_page( $r );
		
		if ($r['type'] == PAGE_FOLDER_ID && isset($r['open_url'])) {
			unset($r['open_url']);
		}
		echo( json_encode($r) );
		exit();
	}
	if (!isset($html['meta']['plugin_custom_page_make_page'])) {
$html['meta']['plugin_custom_page_make_page'] = <<<EOT
		<script>
		ot.plugin_custom_page_make_page = function (link,type) {
			var opt = "ajax=plugin_custom_page_make_page";
			opt += "&type="+type+"&page="+link;
			ot.ajax({
				type: "POST"
				, url: '{$_SERVER['REQUEST_URI']}'
				, data: opt
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						if ( data['open_url'] ) {
							location.href = data['open_url'];
						} else {
							location.reload(true);
						}
					} else {
						alert('Failure to create a page.');
					}
				}
			});
		};
		</script>
EOT;
	}
}

function page_custom_page_setting()
{
	global $html,$params,$ut;

$params['add-blockmenu'][] = <<<EOT
	<a href='javascript:void(ot.page_custom_page_setting())' class='onethird-button mini'>Setting</a>
EOT;

	// 設定
	if (check_rights('edit')) {
		snippet_std_setting("Setting","page_custom_page_setting");
		if (isset($_POST['ajax']) && $_POST['ajax'] == "page_custom_page_setting")  {
			$r = array();
			$r['result'] = true;
			$page_ar = $params['page'];
			$r['id'] = $p_id = $params['page']['id'];
			$r['title'] = $params['page']['title'];

			if (empty($r['meta']['page_custom_page_opt'])) {
				$r['meta']['page_custom_page_opt'] = '';
			}

$r['html'] = <<<EOT
			<table>
				<tr>
					<td >Title</td>
					<td>
						<input type='text' value='{$page_ar['title']}' data-input='page_custom_page_title' />
					</td>
				</tr>
				<tr>
					<td >option</td>
					<td>
						<input type='text' value='{$r['meta']['page_custom_page_opt']}'  data-input='page_custom_page_opt' />
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}

		if (isset($_POST['ajax']) && $_POST['ajax'] == 'save_page_custom_page_setting')  {

			$r = array();
			$r['result'] = false;
			$r['id'] = $params['page']['id'];
			$page_ar = $params['page'];

			if (isset($_POST['page_custom_page_opt'])) {
				$page_ar['meta']['page_custom_page_opt'] = sanitize_str($_POST['page_custom_page_opt']);
			} else {
				unset($page_ar['meta']['page_ctypedb_allow_post']);
			}
			if (isset($_POST['page_custom_page_title'])) {
				$r['title'] = sanitize_str($_POST['page_custom_page_title']);
			} else {
				$r['title'] = '';
			}
			$r['metadata'] = serialize64($page_ar['meta']);
			if (mod_data_items($r)) {
				$r['result'] = true;
			}

			echo(json_encode($r));
			exit();
		}
	}

}

?>